/*
 * Copyright (c) 2012-2015 Andes Technology Corporation
 * All rights reserved.
 *
 */
#include <stdio.h>
#include <ctype.h> /* for toupper() */
#include "platform.h"

int main()
{
	extern unsigned char __bin_start, __bin_end;
	unsigned int bin_size = &__bin_start-&__bin_end;

	printf("\n\r");
	printf(">>> demo printf: start <<<\n\r");
	printf("if you see all messages in UPPER case, then nds_write() is overridden!\n\r");
	printf("=== demo printf: end ===\n\r");

	return 0;
}

/*
 * override putchar
 */
#undef putchar
inline int putchar(int c)
{
	uart_putc(toupper(c));
	return c;
}

__attribute__((used))
void nds_write(const unsigned char *buf, int size)
{
	int i;
	for (i = 0; i < size; i++)
		putchar(buf[i]);
}
